"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .activityeventparams import ActivityEventParams, ActivityEventParamsTypedDict
from datetime import datetime
from enum import Enum
from glean.api_client.types import BaseModel
from typing import Optional
from typing_extensions import NotRequired, TypedDict


class ActivityEventAction(str, Enum):
    r"""The type of activity this represents."""

    VIEW = "VIEW"
    EDIT = "EDIT"
    SEARCH = "SEARCH"
    COMMENT = "COMMENT"
    CRAWL = "CRAWL"
    HISTORICAL_SEARCH = "HISTORICAL_SEARCH"
    HISTORICAL_VIEW = "HISTORICAL_VIEW"


class ActivityEventTypedDict(TypedDict):
    action: ActivityEventAction
    r"""The type of activity this represents."""
    timestamp: datetime
    r"""The ISO 8601 timestamp when the activity began."""
    url: str
    r"""The URL of the activity."""
    id: NotRequired[str]
    r"""Universally unique identifier of the event. To allow for reliable retransmission, only the earliest received event of a given UUID is considered valid by the server and subsequent are ignored."""
    params: NotRequired[ActivityEventParamsTypedDict]


class ActivityEvent(BaseModel):
    action: ActivityEventAction
    r"""The type of activity this represents."""

    timestamp: datetime
    r"""The ISO 8601 timestamp when the activity began."""

    url: str
    r"""The URL of the activity."""

    id: Optional[str] = None
    r"""Universally unique identifier of the event. To allow for reliable retransmission, only the earliest received event of a given UUID is considered valid by the server and subsequent are ignored."""

    params: Optional[ActivityEventParams] = None
