"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from enum import Enum
from glean.api_client.types import BaseModel
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class BulkUploadHistoryEventStatus(str, Enum):
    r"""The status of the upload, an enum of ACTIVE, SUCCESSFUL"""

    ACTIVE = "ACTIVE"
    SUCCESSFUL = "SUCCESSFUL"


class ProcessingState(str, Enum):
    r"""The current state of the upload, an enum of UNAVAILABLE, UPLOAD STARTED, UPLOAD IN PROGRESS, UPLOAD COMPLETED, DELETION PAUSED, INDEXING COMPLETED"""

    UNAVAILABLE = "UNAVAILABLE"
    UPLOAD_STARTED = "UPLOAD STARTED"
    UPLOAD_IN_PROGRESS = "UPLOAD IN PROGRESS"
    UPLOAD_COMPLETED = "UPLOAD COMPLETED"
    DELETION_PAUSED = "DELETION PAUSED"
    INDEXING_COMPLETED = "INDEXING COMPLETED"


class BulkUploadHistoryEventTypedDict(TypedDict):
    r"""Information about a successful bulk upload"""

    upload_id: NotRequired[str]
    r"""The unique ID of the upload"""
    start_time: NotRequired[str]
    r"""The start time of the upload in ISO 8601 format"""
    end_time: NotRequired[str]
    r"""The end time of the upload in ISO 8601 format, 'NA' if the upload is still active"""
    status: NotRequired[BulkUploadHistoryEventStatus]
    r"""The status of the upload, an enum of ACTIVE, SUCCESSFUL"""
    processing_state: NotRequired[ProcessingState]
    r"""The current state of the upload, an enum of UNAVAILABLE, UPLOAD STARTED, UPLOAD IN PROGRESS, UPLOAD COMPLETED, DELETION PAUSED, INDEXING COMPLETED"""


class BulkUploadHistoryEvent(BaseModel):
    r"""Information about a successful bulk upload"""

    upload_id: Annotated[Optional[str], pydantic.Field(alias="uploadId")] = None
    r"""The unique ID of the upload"""

    start_time: Annotated[Optional[str], pydantic.Field(alias="startTime")] = None
    r"""The start time of the upload in ISO 8601 format"""

    end_time: Annotated[Optional[str], pydantic.Field(alias="endTime")] = None
    r"""The end time of the upload in ISO 8601 format, 'NA' if the upload is still active"""

    status: Optional[BulkUploadHistoryEventStatus] = None
    r"""The status of the upload, an enum of ACTIVE, SUCCESSFUL"""

    processing_state: Annotated[
        Optional[ProcessingState], pydantic.Field(alias="processingState")
    ] = None
    r"""The current state of the upload, an enum of UNAVAILABLE, UPLOAD STARTED, UPLOAD IN PROGRESS, UPLOAD COMPLETED, DELETION PAUSED, INDEXING COMPLETED"""
