"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .iconconfig import IconConfig, IconConfigTypedDict
from .person import Person, PersonTypedDict
from glean.api_client.types import BaseModel
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class ChatMetadataTypedDict(TypedDict):
    r"""Metadata of a Chat a user had with Glean Assistant. This contains no actual conversational content."""

    id: NotRequired[str]
    r"""The opaque id of the Chat."""
    create_time: NotRequired[int]
    r"""Server Unix timestamp of the creation time (in seconds since epoch UTC)."""
    created_by: NotRequired[PersonTypedDict]
    update_time: NotRequired[int]
    r"""Server Unix timestamp of the update time (in seconds since epoch UTC)."""
    name: NotRequired[str]
    r"""The name of the Chat."""
    application_id: NotRequired[str]
    r"""The ID of the AI App that this Chat is associated to."""
    application_name: NotRequired[str]
    r"""The display name of the AI App that this Chat is associated to."""
    icon: NotRequired[IconConfigTypedDict]
    r"""Defines how to render an icon"""


class ChatMetadata(BaseModel):
    r"""Metadata of a Chat a user had with Glean Assistant. This contains no actual conversational content."""

    id: Optional[str] = None
    r"""The opaque id of the Chat."""

    create_time: Annotated[Optional[int], pydantic.Field(alias="createTime")] = None
    r"""Server Unix timestamp of the creation time (in seconds since epoch UTC)."""

    created_by: Annotated[Optional[Person], pydantic.Field(alias="createdBy")] = None

    update_time: Annotated[Optional[int], pydantic.Field(alias="updateTime")] = None
    r"""Server Unix timestamp of the update time (in seconds since epoch UTC)."""

    name: Optional[str] = None
    r"""The name of the Chat."""

    application_id: Annotated[Optional[str], pydantic.Field(alias="applicationId")] = (
        None
    )
    r"""The ID of the AI App that this Chat is associated to."""

    application_name: Annotated[
        Optional[str], pydantic.Field(alias="applicationName")
    ] = None
    r"""The display name of the AI App that this Chat is associated to."""

    icon: Optional[IconConfig] = None
    r"""Defines how to render an icon"""
