"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .facetbucket import FacetBucket, FacetBucketTypedDict
from glean.api_client.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class FacetResultTypedDict(TypedDict):
    source_name: NotRequired[str]
    r"""The source of this facet (e.g. container_name, type, last_updated_at)."""
    operator_name: NotRequired[str]
    r"""How to display this facet. Currently supportes 'SelectSingle' and 'SelectMultiple'."""
    buckets: NotRequired[List[FacetBucketTypedDict]]
    r"""A list of unique buckets that exist within this result set."""
    has_more_buckets: NotRequired[bool]
    r"""Returns true if more buckets exist than those returned. Additional buckets can be retrieve by requesting again with a higher facetBucketSize."""
    group_name: NotRequired[str]
    r"""For most facets this will be the empty string, meaning the facet is high-level and applies to all documents for the datasource. When non-empty, this is used to group facets together (i.e. group facets for each doctype for a certain datasource)"""


class FacetResult(BaseModel):
    source_name: Annotated[Optional[str], pydantic.Field(alias="sourceName")] = None
    r"""The source of this facet (e.g. container_name, type, last_updated_at)."""

    operator_name: Annotated[Optional[str], pydantic.Field(alias="operatorName")] = None
    r"""How to display this facet. Currently supportes 'SelectSingle' and 'SelectMultiple'."""

    buckets: Optional[List[FacetBucket]] = None
    r"""A list of unique buckets that exist within this result set."""

    has_more_buckets: Annotated[
        Optional[bool], pydantic.Field(alias="hasMoreBuckets")
    ] = None
    r"""Returns true if more buckets exist than those returned. Additional buckets can be retrieve by requesting again with a higher facetBucketSize."""

    group_name: Annotated[Optional[str], pydantic.Field(alias="groupName")] = None
    r"""For most facets this will be the empty string, meaning the facet is high-level and applies to all documents for the datasource. When non-empty, this is used to group facets together (i.e. group facets for each doctype for a certain datasource)"""
