"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .facetresult import FacetResult, FacetResultTypedDict
from .feedresult import FeedResult, FeedResultTypedDict
from glean.api_client.types import BaseModel
import pydantic
from typing import Dict, List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class FeedResponseTypedDict(TypedDict):
    server_timestamp: int
    r"""Server unix timestamp (in seconds since epoch UTC)."""
    experiment_ids: NotRequired[List[int]]
    r"""List of experiment ids for the corresponding request."""
    tracking_token: NotRequired[str]
    r"""An opaque token that represents this particular feed response."""
    results: NotRequired[List[FeedResultTypedDict]]
    facet_results: NotRequired[Dict[str, List[FacetResultTypedDict]]]
    r"""Map from category to the list of facets that can be used to filter the entry's content."""
    mentions_time_window_in_hours: NotRequired[int]
    r"""The time window (in hours) used for generating user mentions."""


class FeedResponse(BaseModel):
    server_timestamp: Annotated[int, pydantic.Field(alias="serverTimestamp")]
    r"""Server unix timestamp (in seconds since epoch UTC)."""

    experiment_ids: Annotated[
        Optional[List[int]], pydantic.Field(alias="experimentIds")
    ] = None
    r"""List of experiment ids for the corresponding request."""

    tracking_token: Annotated[Optional[str], pydantic.Field(alias="trackingToken")] = (
        None
    )
    r"""An opaque token that represents this particular feed response."""

    results: Optional[List[FeedResult]] = None

    facet_results: Annotated[
        Optional[Dict[str, List[FacetResult]]], pydantic.Field(alias="facetResults")
    ] = None
    r"""Map from category to the list of facets that can be used to filter the entry's content."""

    mentions_time_window_in_hours: Annotated[
        Optional[int], pydantic.Field(alias="mentionsTimeWindowInHours")
    ] = None
    r"""The time window (in hours) used for generating user mentions."""
