"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .timerange import TimeRange, TimeRangeTypedDict
from enum import Enum
from glean.api_client.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class DatasourcesType(str, Enum):
    r"""The types of datasource for which to run the report/policy."""

    ALL = "ALL"
    CUSTOM = "CUSTOM"


class TimePeriodType(str, Enum):
    r"""Type of time period for which to run the report/policy. PAST_DAY is deprecated."""

    ALL_TIME = "ALL_TIME"
    PAST_YEAR = "PAST_YEAR"
    PAST_DAY = "PAST_DAY"
    CUSTOM = "CUSTOM"


class InputOptionsTypedDict(TypedDict):
    r"""Controls which data-sources and what time-range to include in scans."""

    url_greenlist: NotRequired[List[str]]
    r"""list of url regex matching documents excluded from report"""
    datasources_type: NotRequired[DatasourcesType]
    r"""The types of datasource for which to run the report/policy."""
    datasources: NotRequired[List[str]]
    r"""List of datasources to consider for report. DEPRECATED - use datasourceInstances instead."""
    datasource_instances: NotRequired[List[str]]
    r"""List of datasource instances to consider for report/policy."""
    time_period_type: NotRequired[TimePeriodType]
    r"""Type of time period for which to run the report/policy. PAST_DAY is deprecated."""
    custom_time_range: NotRequired[TimeRangeTypedDict]


class InputOptions(BaseModel):
    r"""Controls which data-sources and what time-range to include in scans."""

    url_greenlist: Annotated[
        Optional[List[str]],
        pydantic.Field(
            deprecated="warning: ** DEPRECATED ** - This will be removed in a future release, please migrate away from it as soon as possible.",
            alias="urlGreenlist",
        ),
    ] = None
    r"""list of url regex matching documents excluded from report"""

    datasources_type: Annotated[
        Optional[DatasourcesType], pydantic.Field(alias="datasourcesType")
    ] = None
    r"""The types of datasource for which to run the report/policy."""

    datasources: Annotated[
        Optional[List[str]],
        pydantic.Field(
            deprecated="warning: ** DEPRECATED ** - This will be removed in a future release, please migrate away from it as soon as possible."
        ),
    ] = None
    r"""List of datasources to consider for report. DEPRECATED - use datasourceInstances instead."""

    datasource_instances: Annotated[
        Optional[List[str]], pydantic.Field(alias="datasourceInstances")
    ] = None
    r"""List of datasource instances to consider for report/policy."""

    time_period_type: Annotated[
        Optional[TimePeriodType], pydantic.Field(alias="timePeriodType")
    ] = None
    r"""Type of time period for which to run the report/policy. PAST_DAY is deprecated."""

    custom_time_range: Annotated[
        Optional[TimeRange], pydantic.Field(alias="customTimeRange")
    ] = None
